#include "Frustum.h"

Frustum::Frustum() {
	Update();
}

void Frustum::Update(){

	float projm[16], modm[16], clip[16];
	glGetFloatv(GL_PROJECTION_MATRIX, projm);
	glGetFloatv(GL_MODELVIEW_MATRIX, modm);

	/*clip[ 0] = modm[ 0]*projm[ 0]+modm[ 1]*projm[ 4]+
		       modm[ 2]*projm[ 8]+modm[ 3]*projm[12];
	clip[ 1] = modm[ 0]*projm[ 1]+modm[ 1]*projm[ 5]+
		       modm[ 2]*projm[ 9]+modm[ 3]*projm[13];
	clip[ 2] = modm[ 0]*projm[ 2]+modm[ 1]*projm[ 6]+
		       modm[ 2]*projm[10]+modm[ 3]*projm[14];
	clip[ 3] = modm[ 0]*projm[ 3]+modm[ 1]*projm[ 7]+
		       modm[ 2]*projm[11]+modm[ 3]*projm[15];
	clip[ 4] = modm[ 4]*projm[ 0]+modm[ 5]*projm[ 4]+
		       modm[ 6]*projm[ 8]+modm[ 7]*projm[12];
	clip[ 5] = modm[ 4]*projm[ 1]+modm[ 5]*projm[ 5]+
		       modm[ 6]*projm[ 9]+modm[ 7]*projm[13];
	clip[ 6] = modm[ 4]*projm[ 2]+modm[ 5]*projm[ 6]+
		       modm[ 6]*projm[10]+modm[ 7]*projm[14];
	clip[ 7] = modm[ 4]*projm[ 3]+modm[ 5]*projm[ 7]+
		       modm[ 6]*projm[11]+modm[ 7]*projm[15];
	clip[ 8] = modm[ 8]*projm[ 0]+modm[ 9]*projm[ 4]+
		       modm[10]*projm[ 8]+modm[11]*projm[12];
	clip[ 9] = modm[ 8]*projm[ 1]+modm[ 9]*projm[ 5]+
		       modm[10]*projm[ 9]+modm[11]*projm[13];
	clip[10] = modm[ 8]*projm[ 2]+modm[ 9]*projm[ 6]+
		       modm[10]*projm[10]+modm[11]*projm[14];
	clip[11] = modm[ 8]*projm[ 3]+modm[ 9]*projm[ 7]+
		       modm[10]*projm[11]+modm[11]*projm[15];
	clip[12] = modm[12]*projm[ 0]+modm[13]*projm[ 4]+
		       modm[14]*projm[ 8]+modm[15]*projm[12];
	clip[13] = modm[12]*projm[ 1]+modm[13]*projm[ 5]+
		       modm[14]*projm[ 9]+modm[15]*projm[13];
	clip[14] = modm[12]*projm[ 2]+modm[13]*projm[ 6]+
		       modm[14]*projm[10]+modm[15]*projm[14];
	clip[15] = modm[12]*projm[ 3]+modm[13]*projm[ 7]+
		       modm[14]*projm[11]+modm[15]*projm[15];*/

	for (int i=0; i<4; i++)
		for (int j=0; j<4; j++)
			clip[i*4+j] = modm[i*4]*projm[j] + modm[i*4+1]*projm[j+4] + modm[i*4+2]*projm[j+8] + modm[i*4+3]*projm[j+12];

	frustum[0][0] = clip[ 3]-clip[ 0];
	frustum[0][1] = clip[ 7]-clip[ 4];
	frustum[0][2] = clip[11]-clip[ 8];
	frustum[0][3] = clip[15]-clip[12];
	float length = sqrt(pow(frustum[0][0],2)+pow(frustum[0][1],2)+pow(frustum[0][2],2));
	frustum[0][0] /= length;
	frustum[0][1] /= length;
	frustum[0][2] /= length;
	frustum[0][3] /= length;

	frustum[1][0] = clip[ 3]+clip[ 0];
	frustum[1][1] = clip[ 7]+clip[ 4];
	frustum[1][2] = clip[11]+clip[ 8];
	frustum[1][3] = clip[15]+clip[12];
	length = sqrt(pow(frustum[1][0],2)+pow(frustum[1][1],2)+pow(frustum[1][2],2));
	frustum[1][0] /= length;
	frustum[1][1] /= length;
	frustum[1][2] /= length;
	frustum[1][3] /= length;
	
	frustum[2][0] = clip[ 3]+clip[ 1];
	frustum[2][1] = clip[ 7]+clip[ 5];
	frustum[2][2] = clip[11]+clip[ 9];
	frustum[2][3] = clip[15]+clip[13];
	length = sqrt(pow(frustum[2][0],2)+pow(frustum[2][1],2)+pow(frustum[2][2],2));
	frustum[2][0] /= length;
	frustum[2][1] /= length;
	frustum[2][2] /= length;
	frustum[2][3] /= length;
	
	frustum[3][0] = clip[ 3]-clip[ 1];
	frustum[3][1] = clip[ 7]-clip[ 5];
	frustum[3][2] = clip[11]-clip[ 9];
	frustum[3][3] = clip[15]-clip[13];
	length = sqrt(pow(frustum[3][0],2)+pow(frustum[3][1],2)+pow(frustum[3][2],2));
	frustum[3][0] /= length;
	frustum[3][1] /= length;
	frustum[3][2] /= length;
	frustum[3][3] /= length;
	
	frustum[4][0] = clip[ 3]-clip[ 2];
	frustum[4][1] = clip[ 7]-clip[ 6];
	frustum[4][2] = clip[11]-clip[10];
	frustum[4][3] = clip[15]-clip[14];
	length = sqrt(pow(frustum[4][0],2)+pow(frustum[4][1],2)+pow(frustum[4][2],2));
	frustum[4][0] /= length;
	frustum[4][1] /= length;
	frustum[4][2] /= length;
	frustum[4][3] /= length;
	
	frustum[4][0] = clip[ 3]-clip[ 2];
	frustum[4][1] = clip[ 7]-clip[ 6];
	frustum[4][2] = clip[11]-clip[10];
	frustum[4][3] = clip[15]-clip[14];
	length = sqrt(pow(frustum[4][0],2)+pow(frustum[4][1],2)+pow(frustum[4][2],2));
	frustum[4][0] /= length;
	frustum[4][1] /= length;
	frustum[4][2] /= length;
	frustum[4][3] /= length;

	//for (int i=0; i<6; i+=2) { // Right = 0, Left = 1, Bottom = 2, Top = 3, Back = 4, Front = 5
	//	for (int j=0; j<4; j++) {
	//		frustum[i][j] = clip[3+j*4] - clip[j*4+i];
	//		frustum[i+1][j] = clip[3+j*4] + clip[j*4+i];

	//		if (j==3) {
	//			float length = sqrt(pow(frustum[i][0],2)+pow(frustum[i][1],2)+pow(frustum[i][2],2));
	//			frustum[i][0] /= length;
	//			frustum[i][1] /= length;
	//			frustum[i][2] /= length;
	//			frustum[i][3] /= length;

	//			length = sqrt(pow(frustum[i+1][0],2)+pow(frustum[i+1][1],2)+pow(frustum[i+1][2],2));
	//			frustum[i+1][0] /= length;
	//			frustum[i+1][1] /= length;
	//			frustum[i+1][2] /= length;
	//			frustum[i+1][3] /= length;
	//		}
	//	}
	//}
}

Frustum::~Frustum() {}

bool Frustum::IsSphereWithin(Vector center, float radius) {
	for (int i = 0; i<6; i++) {
		if (frustum[i][0]*center.x + frustum[i][1]*center.y + 
			frustum[i][2]*center.z + frustum[i][3] <= -radius)
			return false;
	}
	return true;
}