#include "global.h"
#include "vector.h"
#include <iostream>
#define MAX_COLL 100


class CollisionBubble {
private:
	Vector M;
	float r;
public:
	CollisionBubble(Vector M, float r) {
		this->M = Vector(M);
		this->r = r;
	}
	CollisionBubble() {}
	~CollisionBubble() {}
	boolean CheckCollision(Vector P, float range);
	void Translate(float x, float y, float z);
};

class CollisionCuboid {
private:
	Vector CubeData[5];
public:
	CollisionCuboid(Vector A, Vector G, Vector X, Vector Y, Vector Z) {
		X.Normalise();
		Y.Normalise();
		Z.Normalise();
		this->CubeData[0] = Vector(A);
		this->CubeData[1] = Vector(G);
		this->CubeData[2] = Vector(X);
		this->CubeData[3] = Vector(Y);
		this->CubeData[4] = Vector(Z);
	}
	CollisionCuboid(){}
	~CollisionCuboid() {}
	boolean CheckCollision(Vector P, float range);
	void Translate(float x, float y, float z);
	void RotateX(float amount, Vector center);
	void RotateY(float amount, Vector center);
	void RotateZ(float amount, Vector center);
};

class CollisionCollection {
private:
	CollisionBubble bubbles[MAX_COLL];
	CollisionCuboid cubes[MAX_COLL];
	int bubblecount, cubecount;
public:
	CollisionCuboid * GetCube(int i);
	CollisionBubble * GetBubble(int i);
	int insert(CollisionBubble b);
	int insert(CollisionCuboid c);
	boolean CheckCollision(Vector P, float range);
	CollisionCollection() {bubblecount = cubecount = 0;}
};
