#include "level.h"
#include <iostream>
#include <fstream>

Level::Level() {
	worldmodelcount = -1;
	worldcoll = CollisionCollection();
	fcull = Frustum();
}
Level::~Level() {}
bool Level::LoadLevel(const char *filename) {
	std::ifstream file;
	
	char tempbuff [50];
	string tempstring;

	file.open(filename, std::ios::in);
	if( file.fail() )
        return false;

	file.getline(tempbuff, 50, '\n');	
	string s = tempbuff;

	if (s != "TornAndSewn LevelFile 1.0") {
		file.close();
		return false;
	}
	
	file.getline(tempbuff, 50, '\n');
	file.getline(tempbuff, 50, '\n');
	file.getline(tempbuff, 50, '\n');

	worldmodelcount = atoi(tempbuff);

	file.getline(tempbuff, 50, '\n');
	file.getline(tempbuff, 50, '\n');
	file.getline(tempbuff, 50, '\n');
	file.getline(tempbuff, 50, '\n');
	file.getline(tempbuff, 50, '\n');
	file.getline(tempbuff, 50, '\n');
	file.getline(tempbuff, 50, '\n');
	file.getline(tempbuff, 50, '\n');

	world = new Model[worldmodelcount];
	animation = new int[worldmodelcount];

	int i = -1;

	for (i = 0; i < worldmodelcount; i++) {
		file.getline(tempbuff, 50, '\n');	
		s = tempbuff;
		std::cout << s << std::endl;
		if (s == "####EndModelList####") {
			std::cout << s << std::endl;
			break;
		}
		world[i].LoadMD2(tempbuff);

		file.getline(tempbuff, 50, '\n');	
		s = tempbuff;
		std::cout << s << std::endl;
		if (s == "####EndModelList####")
			world[i].LoadTex("#default#");
		else
			world[i].LoadTex(tempbuff);

		file.getline(tempbuff, 50, '\n');
		s = tempbuff;
		std::cout << s << std::endl;
		if (s == "####EndModelList####")
			world[i].ScaleModel(1.0);
		else
			world[i].ScaleModel(atof(tempbuff));

		file.getline(tempbuff, 50, '\n');	
		s = tempbuff;
		std::cout << s << std::endl;
		if (s == "animated") animation[i] = 1;
		else if (s == "static") animation[i] = 0;
		else animation[i] = 2;
			
		CollisionCreator creator = CollisionCreator();

		file.getline(tempbuff, 50, '\n');	
		s = tempbuff;
		std::cout << s << std::endl;
		if (s == "cuboid")
			worldcoll.insert(creator.ModelToCuboid(world[i], 0));
		else if (s == "bubble") {
			file.getline(tempbuff, 50, '\n');
			s = tempbuff;
			std::cout << s << std::endl;
			worldcoll.insert(creator.ModelToBubble(world[i], 0, atoi(tempbuff)));
		}
		else if (s == "plane") {
			worldcoll.insert(creator.ModelToPlane(world[i], 0));
		}

		file.getline(tempbuff, 50, '\n');
		s = tempbuff;
		std::cout << s << std::endl;
		if (s == "####EndModelList####")
			break;
		
		world[i].MakeFrustumSphere();
	}

	if (i != worldmodelcount) worldmodelcount = i;

	file.close();

	return true;
}

void Level::DrawScene(float time, bool wireframe, bool frustum) {
	fcull.Update();
	for (int i = 0; i < worldmodelcount; i++) {
		if (!frustum || fcull.IsSphereWithin(world[i].GetFrustumCenter(), world[i].GetFrustumRadius())) {
			if (animation[i]==1) world[i].DrawMD2(time, wireframe);
			if (animation[i]==0) world[i].DrawFrame(0, wireframe);
		}
	}
}